using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Xml;

namespace Glow
{
	/// <summary>
	/// Zusammenfassung für Form1.
	/// </summary>
	public class ObjectForm : System.Windows.Forms.Form
	{
		private XmlDocument cfg = new XmlDocument();
		private System.Globalization.NumberFormatInfo ns = System.Globalization.NumberFormatInfo.InvariantInfo;
		private Bitmap bmp = null;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.NumericUpDown numericUpDownW;
		private System.Windows.Forms.NumericUpDown numericUpDownH;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ComboBox comboBoxNS;
		private System.Windows.Forms.ComboBox comboBoxWE;
		private System.Windows.Forms.NumericUpDown numericUpDownOY;
		private System.Windows.Forms.NumericUpDown numericUpDownOX;
		private System.Windows.Forms.NumericUpDown numericUpDownZoom;
		private System.Windows.Forms.TextBox textBoxResult;
		private System.Windows.Forms.Label label1;

		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ObjectForm()
		{
			//
			// Erforderlich für die Windows Form-Designerunterstützung
			//
			InitializeComponent();
			textBox1.Text = System.IO.Directory.GetCurrentDirectory();
			FillListbox();
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode für die Designerunterstützung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.numericUpDownZoom = new System.Windows.Forms.NumericUpDown();
			this.comboBoxWE = new System.Windows.Forms.ComboBox();
			this.comboBoxNS = new System.Windows.Forms.ComboBox();
			this.numericUpDownOY = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownOX = new System.Windows.Forms.NumericUpDown();
			this.label4 = new System.Windows.Forms.Label();
			this.numericUpDownH = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownW = new System.Windows.Forms.NumericUpDown();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.panel2 = new System.Windows.Forms.Panel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.textBoxResult = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownZoom)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownH)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownW)).BeginInit();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.textBoxResult);
			this.panel1.Controls.Add(this.numericUpDownZoom);
			this.panel1.Controls.Add(this.comboBoxWE);
			this.panel1.Controls.Add(this.comboBoxNS);
			this.panel1.Controls.Add(this.numericUpDownOY);
			this.panel1.Controls.Add(this.numericUpDownOX);
			this.panel1.Controls.Add(this.label4);
			this.panel1.Controls.Add(this.numericUpDownH);
			this.panel1.Controls.Add(this.numericUpDownW);
			this.panel1.Controls.Add(this.statusBar1);
			this.panel1.Controls.Add(this.button2);
			this.panel1.Controls.Add(this.textBox1);
			this.panel1.Controls.Add(this.listBox1);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Controls.Add(this.label3);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(280, 566);
			this.panel1.TabIndex = 0;
			// 
			// numericUpDownZoom
			// 
			this.numericUpDownZoom.Location = new System.Drawing.Point(184, 40);
			this.numericUpDownZoom.Minimum = new System.Decimal(new int[] {
																			  1,
																			  0,
																			  0,
																			  0});
			this.numericUpDownZoom.Name = "numericUpDownZoom";
			this.numericUpDownZoom.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownZoom.TabIndex = 25;
			this.numericUpDownZoom.Value = new System.Decimal(new int[] {
																			1,
																			0,
																			0,
																			0});
			this.numericUpDownZoom.ValueChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// comboBoxWE
			// 
			this.comboBoxWE.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.comboBoxWE.Items.AddRange(new object[] {
															"w",
															"c",
															"e"});
			this.comboBoxWE.Location = new System.Drawing.Point(104, 408);
			this.comboBoxWE.Name = "comboBoxWE";
			this.comboBoxWE.Size = new System.Drawing.Size(72, 21);
			this.comboBoxWE.TabIndex = 24;
			this.comboBoxWE.Text = "c";
			this.comboBoxWE.SelectedIndexChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// comboBoxNS
			// 
			this.comboBoxNS.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.comboBoxNS.Items.AddRange(new object[] {
															"n",
															"c",
															"s"});
			this.comboBoxNS.Location = new System.Drawing.Point(184, 408);
			this.comboBoxNS.Name = "comboBoxNS";
			this.comboBoxNS.Size = new System.Drawing.Size(72, 21);
			this.comboBoxNS.TabIndex = 23;
			this.comboBoxNS.Text = "c";
			this.comboBoxNS.SelectedIndexChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// numericUpDownOY
			// 
			this.numericUpDownOY.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.numericUpDownOY.Location = new System.Drawing.Point(184, 472);
			this.numericUpDownOY.Maximum = new System.Decimal(new int[] {
																			1024,
																			0,
																			0,
																			0});
			this.numericUpDownOY.Minimum = new System.Decimal(new int[] {
																			1024,
																			0,
																			0,
																			-2147483648});
			this.numericUpDownOY.Name = "numericUpDownOY";
			this.numericUpDownOY.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownOY.TabIndex = 21;
			this.numericUpDownOY.ValueChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// numericUpDownOX
			// 
			this.numericUpDownOX.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.numericUpDownOX.Location = new System.Drawing.Point(104, 472);
			this.numericUpDownOX.Maximum = new System.Decimal(new int[] {
																			1024,
																			0,
																			0,
																			0});
			this.numericUpDownOX.Minimum = new System.Decimal(new int[] {
																			1024,
																			0,
																			0,
																			-2147483648});
			this.numericUpDownOX.Name = "numericUpDownOX";
			this.numericUpDownOX.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownOX.TabIndex = 20;
			this.numericUpDownOX.ValueChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// label4
			// 
			this.label4.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.label4.Location = new System.Drawing.Point(8, 472);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(120, 23);
			this.label4.TabIndex = 22;
			this.label4.Text = "Offset X/Y:";
			// 
			// numericUpDownH
			// 
			this.numericUpDownH.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.numericUpDownH.Location = new System.Drawing.Point(184, 440);
			this.numericUpDownH.Maximum = new System.Decimal(new int[] {
																		   1024,
																		   0,
																		   0,
																		   0});
			this.numericUpDownH.Name = "numericUpDownH";
			this.numericUpDownH.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownH.TabIndex = 17;
			this.numericUpDownH.ValueChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// numericUpDownW
			// 
			this.numericUpDownW.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.numericUpDownW.Location = new System.Drawing.Point(104, 440);
			this.numericUpDownW.Maximum = new System.Decimal(new int[] {
																		   1024,
																		   0,
																		   0,
																		   0});
			this.numericUpDownW.Name = "numericUpDownW";
			this.numericUpDownW.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownW.TabIndex = 16;
			this.numericUpDownW.ValueChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 544);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(280, 22);
			this.statusBar1.SizingGrip = false;
			this.statusBar1.TabIndex = 13;
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(136, 8);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(120, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Ordner wählen...";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(8, 8);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(120, 20);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "." + Path.DirectorySeparatorChar;
			// 
			// listBox1
			// 
			this.listBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.listBox1.Location = new System.Drawing.Point(8, 64);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(248, 329);
			this.listBox1.TabIndex = 4;
			this.listBox1.SelectedIndexChanged += new System.EventHandler(this.listBox1_SelectedIndexChanged);
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.label2.Location = new System.Drawing.Point(8, 408);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(120, 23);
			this.label2.TabIndex = 18;
			this.label2.Text = "Alignment:";
			// 
			// label3
			// 
			this.label3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.label3.Location = new System.Drawing.Point(8, 440);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(120, 23);
			this.label3.TabIndex = 19;
			this.label3.Text = "W/H:";
			// 
			// panel2
			// 
			this.panel2.AutoScroll = true;
			this.panel2.Controls.Add(this.pictureBox1);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(280, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(352, 566);
			this.panel2.TabIndex = 1;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(256, 256);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);
			// 
			// folderBrowserDialog1
			// 
			this.folderBrowserDialog1.Description = "Glow-Stammverzeichnis wählen";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "xml";
			this.saveFileDialog1.Filter = "Tile-Sets (T*.xml)|T*.xml";
			this.saveFileDialog1.Title = "Tile-Sets speichern";
			// 
			// textBoxResult
			// 
			this.textBoxResult.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.textBoxResult.Location = new System.Drawing.Point(8, 512);
			this.textBoxResult.Name = "textBoxResult";
			this.textBoxResult.Size = new System.Drawing.Size(248, 20);
			this.textBoxResult.TabIndex = 26;
			this.textBoxResult.Text = "";
			this.textBoxResult.Enter += new System.EventHandler(this.textBoxResult_Enter);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.label1.Location = new System.Drawing.Point(8, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(120, 23);
			this.label1.TabIndex = 27;
			this.label1.Text = "Zoom:";
			// 
			// ObjectForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 566);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel1);
			this.Name = "ObjectForm";
			this.Text = "Glow Tileset-Tool von Thiemo Mättig";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownZoom)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownH)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownW)).EndInit();
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt für die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new ObjectForm());
		}

		private void FillListbox()
		{
			string path = textBox1.Text;
			if (!path.EndsWith(Path.DirectorySeparatorChar.ToString()))
				path += Path.DirectorySeparatorChar;
			path += "Config" + Path.DirectorySeparatorChar;
			if (!File.Exists(path + "EntityDescriptions.xml"))
			{
				MessageBox.Show("XML-Datei(en) nicht gefunden.");
				return;
			}
			listBox1.Items.Clear();

			cfg.Load(path + @"EntityDescriptions.xml");
			//cfg.Load(path + @"EnemyDescriptions.xml");

			foreach (XmlNode node in cfg.SelectNodes("*/Description/@class"))
			{
				listBox1.Items.Add(node.Value);
			}
			if (listBox1.Items.Count > 0)
				listBox1.SelectedIndex = 0;
			listBox1.Select();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			folderBrowserDialog1.SelectedPath = textBox1.Text;
			if (folderBrowserDialog1.ShowDialog(this) != DialogResult.OK)
				return;
			textBox1.Text = folderBrowserDialog1.SelectedPath;
			FillListbox();
		}

		private void doRefresh(object sender, System.EventArgs e)
		{
			string text = "<BoundingBox width=\"";
			text += ((double) numericUpDownW.Value / 64.0).ToString(ns);
			text += "\" height=\"";
			text += ((double) numericUpDownH.Value / 64.0).ToString(ns);
			text += "\" typeX=\"";
			text += comboBoxWE.SelectedItem;
			text += "\" typeY=\"";
			text += comboBoxNS.SelectedItem;
			text += "\" offsetX=\"";
			text += ((double) numericUpDownOY.Value / 32.0).ToString(ns);
			text += "\" offsetY=\"";
			text += ((double) numericUpDownOY.Value / 32.0).ToString(ns);
			text += "\" />";
			textBoxResult.Text = text;
			pictureBox1.Refresh();
		}

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			int bw = (int) numericUpDownW.Value;
			int bh = (int) numericUpDownH.Value;
			int ox = (int) numericUpDownOX.Value;
			int oy = (int) numericUpDownOY.Value;

			Graphics g = e.Graphics;
			g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighSpeed;
			g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
			g.Clear(Color.Gray);
			Pen boxPen = new Pen(Color.FromArgb(0x99, Color.Lime));

			int scale = (int) numericUpDownZoom.Value;
			int w = (int) bmp.PhysicalDimension.Width;
			int h = (int) bmp.PhysicalDimension.Height;
			pictureBox1.Width = w * scale;
			pictureBox1.Height = h * scale;

			if (bmp != null)
				g.DrawImage(bmp, scale / 2, scale / 2, w * scale, h * scale);

			int x, y;
			switch (comboBoxWE.SelectedItem.ToString())
			{
				case "c":
					x = (w - bw) / 2;
					break;
				case "e":
					x = w - bw;
					break;
				default:
					x = 0;
					break;
			}
			switch (comboBoxNS.SelectedItem.ToString())
			{
				case "c":
					y = (h - bh) / 2;
					break;
				case "s":
					y = h - bh;
					break;
				default:
					y = 0;
					break;
			}
			x -= ox;
			y -= oy;

			g.DrawRectangle(boxPen, x * scale, y * scale, bw * scale - 1, bh * scale - 1);
			
/*
			int memoryWidth = Convert.ToInt32(cfgSet.Attributes["width"].Value);
			int memoryHeight = Convert.ToInt32(cfgSet.Attributes["height"].Value);
			if ((memoryWidth & (memoryWidth - 1)) != 0 || (memoryHeight & (memoryHeight - 1)) != 0)
			{
				MessageBox.Show("Größe ist nicht Power-of-Two.");
			}
			int width = memoryWidth, height = memoryHeight;
			Brush[] brush = new Brush[2];
			brush[0] = new SolidBrush(Color.FromArgb(4, Color.Black));
			brush[1] = new SolidBrush(Color.FromArgb(4, Color.White));
			for (int y = 0; y < height; y += 32)
			{
				for (int x = 0; x < width; x += 32)
				{
					g.FillRectangle(brush[((x + y) / 32) % 2], x, y, 32, 32);
				}
			}

			Brush boxBrush = new SolidBrush(Color.FromArgb(40, Color.Blue));
			//boxPen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;

			bool[,] usage = new bool[width / 32, height / 32];
			int area = 0;

			foreach (XmlNode node in cfgSet.ChildNodes)
			{
				if (node.NodeType != XmlNodeType.Element)
					continue;
				try
				{
					try
					{
						bmp = new Bitmap(filename);
					}
					catch (ArgumentException ex)
					{
						Graphics g2 = Graphics.FromImage(bmp);
						g2.FillRectangle(Brushes.Red, 0, 0, bmp.Width, bmp.Height);
						g2.Dispose();
					}
					area += (bmp.Width / 32) * (bmp.Height / 32);

					int posX = -1, posY = -1;
					bool free = false;
					int searchWidth = (width - bmp.Width) / 32;
					int searchStep = 1;
					int cmpWidth = bmp.Width / 32;
					for (int y = 0; y <= (height - bmp.Height) / 32; y++)
					{
						for (int x = 0; x <= searchWidth; x += searchStep)
						{
							free = true;
							for (int y2 = 0; y2 < bmp.Height / 32; y2++)
							{
								for (int x2 = 0; x2 < cmpWidth; x2++)
								{
									if (usage[x + x2, y + y2])
									{
										free = false;
										break;
									}
								}
								if (! free)
									break;
							}
							if (free)
							{
								posX = x * 32;
								posY = y * 32;
								break;
							}
						}
						if (posX >= 0)
							break;
					}
					if (posX < 0 || posY < 0)
					{
						//MessageBox.Show("Nicht genug Platz im Set.");
						//return;
						g.FillRectangle(new SolidBrush(Color.FromArgb(127, 255, 0, 0)),
							0, 0, width, height);
						continue;
					}

					g.DrawImage(bmp, posX, posY,
						bmp.PhysicalDimension.Width, bmp.PhysicalDimension.Height);
					g.DrawRectangle(boxPen, posX, posY,
						bmp.PhysicalDimension.Width - 1, bmp.PhysicalDimension.Height - 1);

					// Als belegt markieren
					for (int x = 0; x < bmp.Width / 32; x++)
					{
						if (posX / 32 + x >= usage.GetLength(0))
							continue;
						for (int y = 0; y < bmp.Height / 32; y++)
						{
							usage[posX / 32 + x, posY / 32 + y] = true;
						}
					}
					bmp.Dispose();
				}
				catch (Exception ex)
				{
					//MessageBox.Show(ex.GetType().FullName);
					//MessageBox.Show("Datei " + filename + " nicht gefunden.");
				}
			}

			int setArea = ((memoryWidth / 32) * (memoryHeight / 32));
			double percent = 100.0 / setArea * area;
			if (percent <= 50.0)
			{
				g.FillRectangle(new SolidBrush(Color.FromArgb(127, 255, 0, 0)), 0, height / 2,
					width - 1, height / 2 - 1);
			}
			statusBar1.Text = "Belegt " + area + " Tiles (" +
				Math.Round(percent) + "%), " + (setArea - area) + " Tiles frei";
*/
		}

		private void listBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (listBox1.SelectedIndex < 0)
				return;

			string className = listBox1.SelectedItem.ToString();
			XmlNode cfgSet = cfg.SelectSingleNode("*/Description[@class='" + className + "']");
			string filename = textBox1.Text + Path.DirectorySeparatorChar;
			int bx = 0, by = 0, bw = 0, bh = 0, ox = 0, oy = 0;
			XmlNode n2;
			if (cfgSet.Attributes["texture"] != null)
			{
				filename += cfgSet.Attributes["texture"].Value;
			}
			else
			{
				n2 = cfg.SelectSingleNode("*/Description[@class='" + className + "']/Animation/@path");
				if (n2 != null)
					filename += n2.Value;
				n2 = cfg.SelectSingleNode("*/Description[@class='" + className + "']/Animation/StackItem[@state='Stand']/@file");
				if (n2 != null)
					filename += n2.Value.Replace(".", "_001.");
			}

			int w = 32, h = 32;

			//<BoundingBox width="0.6875" height="1.640625" typeX="c" typeY="s" offsetX="0" offsetY="0" />
			n2 = cfg.SelectSingleNode("*/Description[@class='" + className + "']/Animation/BoundingBox");
			if (n2 != null)
			{
				bw = (int) Math.Floor(Double.Parse(n2.Attributes["width"].Value, ns) * 64);
				bh = (int) Math.Floor(Double.Parse(n2.Attributes["height"].Value, ns) * 64);
				ox = (int) Math.Floor(Double.Parse(n2.Attributes["offsetX"].Value, ns) * 32);
				oy = (int) Math.Floor(Double.Parse(n2.Attributes["offsetY"].Value, ns) * 32);
				while (w < bw + 2 * Math.Abs(ox))
					w *= 2;
				while (h < bh + 2 * Math.Abs(oy))
					h *= 2;
				comboBoxWE.SelectedItem = n2.Attributes["typeX"].Value;
				comboBoxNS.SelectedItem = n2.Attributes["typeY"].Value;
			}
			else
			{
				if (cfgSet.Attributes["width"] != null)
					bw = (int) Math.Floor(Double.Parse(cfgSet.Attributes["width"].Value, ns) * 64);
				if (cfgSet.Attributes["height"] != null)
					bh = (int) Math.Floor(Double.Parse(cfgSet.Attributes["height"].Value, ns) * 64);
				comboBoxWE.SelectedItem = "c";
				comboBoxNS.SelectedItem = "s";
			}

			bmp = new Bitmap(w, h);
			try
			{
				filename = filename.Replace("/", Path.DirectorySeparatorChar.ToString());
				bmp = new Bitmap(filename);
				w = (int) bmp.PhysicalDimension.Width;
				h = (int) bmp.PhysicalDimension.Height;
			}
			catch (ArgumentException ex)
			{
				Graphics g2 = Graphics.FromImage(bmp);
				g2.FillRectangle(Brushes.Red, 0, 0, bmp.Width, bmp.Height);
				g2.Dispose();
			}

			if (bw <= 0)
				bw = (int) bmp.PhysicalDimension.Width;
			if (bh <= 0)
				bh = (int) bmp.PhysicalDimension.Height;
			numericUpDownW.Value = bw;
			numericUpDownH.Value = bh;
			numericUpDownOX.Value = ox;
			numericUpDownOY.Value = oy;

			doRefresh(sender, e);
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			int index = listBox1.SelectedIndex;
			if (index <= 0)
				return;
			listBox1.Items.Insert(index - 1, listBox1.Items[index]);
			listBox1.Items.RemoveAt(index + 1);
			listBox1.SelectedIndex = index - 1;

			string setName = listBox1.SelectedItem.ToString();
			XmlNode node = cfg.SelectSingleNode("*/TileSet[@id='" + setName + "']");
			while (node.PreviousSibling.NodeType != XmlNodeType.Element)
			{
				node.ParentNode.RemoveChild(node.PreviousSibling);
			}
			XmlNode node2 = node.PreviousSibling;
			node.ParentNode.RemoveChild(node);
			node2.ParentNode.InsertBefore(node, node2);

			doRefresh(sender, e);
			listBox1.Select();
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			int index = listBox1.SelectedIndex;
			if (index >= listBox1.Items.Count - 1)
				return;
			listBox1.Items.Insert(index + 2, listBox1.Items[index]);
			listBox1.Items.RemoveAt(index);
			listBox1.SelectedIndex = index + 1;

			string setName = listBox1.SelectedItem.ToString();
			XmlNode node = cfg.SelectSingleNode("*/TileSet[@id='" + setName + "']");
			while (node.NextSibling.NodeType != XmlNodeType.Element)
			{
				node.ParentNode.RemoveChild(node.NextSibling);
			}
			XmlNode node2 = node.NextSibling;
			node.ParentNode.RemoveChild(node);
			node2.ParentNode.InsertAfter(node, node2);

			doRefresh(sender, e);
			listBox1.Select();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			if (listBox1.SelectedIndex < 0)
				return;
			string name = listBox1.SelectedItem.ToString();
			XmlNode cfgSet = cfg.SelectSingleNode("*/TileSet[@id='" + name + "']");
		}

		private void listBox2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			doRefresh(sender, e);
		}

		private void textBoxResult_Enter(object sender, System.EventArgs e)
		{
			textBoxResult.SelectAll();
			textBoxResult.Copy();
		}
	}
}